#include <FK/FK.h>
#include "FKUT/FrameController.h"
#include "FKUT/TrackBall.h"
#include "FKUT/GuideObject.h"
#include "FKUT/MotionCharactor.h"


int main(int argc, char *argv[])
{
	Fl_Window	mainWindow(800, 600, "FK TEST");
	fk_Model	camera, lightModel;
	fk_Light	light;
	fk_Scene	scene;
	fk_Window	window(0, 0, 800, 600);

	mainWindow.end();
	fk_InitMaterial();

	fk_TrackBall			tb(&window, &camera);
	fkut_FrameController	fps;
	fkut_GuideObject		guide;
	CMotionCharactor		chara;

	// vector<fkut_GuideObject *>	guideArray;

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.setBGColor(0.5f, 0.5f, 0.5f);
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);

	guide.entryScene(&scene);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 50.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);

	mainWindow.show();
	window.show();

	chara.loadObjectData("Girl/girl.mqo");
	chara.loadJointData("Girl/girl_setup.fkc");
	chara.loadMotionData("Girl/issue.fkm");
	chara.entryScene(&scene);
	/*
	for(int i = 0; i < chara.getObjectNum(); i++) {
		guideArray.push_back(new fkut_GuideObject());
		guideArray.back()->setScale(0.5);
		guideArray.back()->setParent(chara.getJointModel(i));
		guideArray.back()->entryScene(&scene);
	}
	*/

	while(true) {
		fps.TimeRegular();

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		tb.update();
		if(window.getKeyStatus(' ', false)) {
			chara.playMotion(0);
		}

		if(fps.GetDrawFlag()) {
			if(window.drawWindow() == 0) break;
		}
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		if(window.getSpecialKeyStatus(FK_UP, false)) {
			chara.getBaseModel()->loTranslate(0, 0, -3);
		}
		if(window.getSpecialKeyStatus(FK_DOWN, false)) {
			chara.getBaseModel()->loTranslate(0, 0, 3);
		}
		if(window.getSpecialKeyStatus(FK_LEFT, false)) {
			chara.getBaseModel()->loFocus(-0.1, 0, -1);
		}
		if(window.getSpecialKeyStatus(FK_RIGHT, false)) {
			chara.getBaseModel()->loFocus( 0.1, 0, -1);
		}
	}

	return 0;
}
